"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _antd = require("antd");
var _ui = require("@react-awesome-query-builder/ui");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _Utils$NumberFormat = _ui.Utils.NumberFormat,
  getNumberFormatProps = _Utils$NumberFormat.getNumberFormatProps,
  numericFormatter = _Utils$NumberFormat.numericFormatter,
  numericParser = _Utils$NumberFormat.numericParser,
  addLeadingZeros = _Utils$NumberFormat.addLeadingZeros,
  addTrailingZeros = _Utils$NumberFormat.addTrailingZeros;
var _default = exports["default"] = function _default(props) {
  var value = props.value,
    setValue = props.setValue,
    readonly = props.readonly,
    placeholder = props.placeholder,
    config = props.config,
    min = props.min,
    max = props.max,
    step = props.step,
    customProps = props.customProps,
    prefix = props.prefix,
    suffix = props.suffix;
  var numericFormatProps = _objectSpread(_objectSpread({}, getNumberFormatProps(props, ["prefix", "suffix"])), {}, {
    min: min,
    max: max
  });
  var numericFormatPropsJson = JSON.stringify(numericFormatProps);
  var renderSize = config.settings.renderSize;
  var aValue = value != undefined ? value : undefined;
  var lastValueRef = (0, _react.useRef)(undefined);
  var extFormatter = (0, _react.useCallback)(function (numOrStr) {
    var _lastValueRef$current;
    var num = parseFloat(numOrStr);
    var prev = lastValueRef.current;
    var extraLeadingZeros, trailingZeros;
    var str = numericFormatter(numOrStr, numericFormatProps);
    if ((prev === null || prev === void 0 ? void 0 : prev.num) === num) {
      if (prev !== null && prev !== void 0 && prev.extraLeadingZeros) {
        // Just to keep zeros in case of `allowLeadingZeros: true`
        extraLeadingZeros = prev.extraLeadingZeros;
        str = addLeadingZeros(str, extraLeadingZeros);
      }
      if (prev !== null && prev !== void 0 && prev.trailingZeros) {
        // To prevent `1.009` -> `1` (should be `1.00`) after removing "9"
        trailingZeros = prev.trailingZeros;
        str = addTrailingZeros(str, trailingZeros);
      }
    }
    if (str !== ((_lastValueRef$current = lastValueRef.current) === null || _lastValueRef$current === void 0 ? void 0 : _lastValueRef$current.str)) {
      lastValueRef.current = {
        num: num,
        str: str,
        extraLeadingZeros: extraLeadingZeros,
        trailingZeros: trailingZeros
      };
    }
    return str;
  }, [numericFormatPropsJson]);
  var extParser = (0, _react.useCallback)(function (str) {
    var prev = lastValueRef.current;
    var prevStr = prev === null || prev === void 0 ? void 0 : prev.str;
    var prevNum = prev === null || prev === void 0 ? void 0 : prev.num;
    var res = numericParser(str, numericFormatProps, prevStr, prevNum);
    if (str !== prevStr) {
      lastValueRef.current = res;
    }
    return res.num;
  }, [numericFormatPropsJson]);
  var handleChange = (0, _react.useCallback)(function (val) {
    if (val === "" || val === null) val = undefined;
    setValue(val);
  }, [setValue]);
  return /*#__PURE__*/_react["default"].createElement(_antd.InputNumber, (0, _extends2["default"])({
    formatter: extFormatter,
    parser: extParser,
    size: renderSize,
    value: aValue,
    placeholder: placeholder,
    disabled: readonly,
    onChange: handleChange,
    min: min,
    max: max,
    step: step,
    prefix: prefix,
    suffix: suffix,
    style: {
      width: "150px"
    }
  }, customProps));
};